************************************************************************
*                                                                      *
*    Datei                                                             *
*      Files.for                                                       *
*                                                                      *
*    Inhalt                                                            *
*      Dateioperationen. Laden und Speichern von Dateien.              *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************
*     Daten_laden. Ldt einen Datensatz.
*     Wird aufgerufen in:
*        Main
*        Menue_Datei
************************************************************************

      Subroutine Daten_laden(Status,Titel,Wert,MS_Name,SW,Pfad,Name)

************************************************************************

      Include 'nT.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i, j               ! Laufvariable
      Integer*2      Status             ! Status des Dateinamens

      Real           Wert(Anzahl)       ! Datenvektor 1
      Real           SW(11,nT)          ! Datenvektor 2

      Character*8    Datum              ! Datum
      Character*10   MS_Name(nT)        ! Masterspeziesnamen
      Character*27   dummy              ! Dummy
      Character*37   Titel(2)           ! Datensatz-Titel
      Character*41   Datensatz          ! Datensatzberschrift

      Character*30   Pfad               ! Dateinpfad
      Character*12   Name               ! Dateiname
      Character*42   Filename           ! vollstndiger Dateiname

************************************************************************

      if (Status.EQ.0) then  ! Filename ber Commandline gegeben
       Status = 0
       call Dateiname(25,7,Status,'\*.DAT',Pfad,Name)
      else
        Status = 1
        call Maske_m('L_DAT')
        call Dateiname(25,7,Status,'\*.DAT',Pfad,Name)
      end if

      if (Status.NE.-1) then
        do i=1,Anzahl
          Wert(i) = 0.0
        end do
        do i=1,nT
          MS_Name(i) = ' '
          do j=1,11
            SW(j,i) = 0.0
          end do
        end do

        call Verbinde_Pfad_Filename(Pfad,Name,Filename)
        open(unit=5,file=Filename)

************************************************************************
*       Einlesen des Datensatzes

        read(5,'(A41,A8)',END=1) Datensatz, Datum
        read(5,'(A)') dummy
        read(5,'(A27,1X,A37)',END=1) dummy, Titel(1)
        read(5,'(A27,1X,A37)',END=1) dummy, Titel(2)

        do i=1,Anzahl
          read(5,'(A27,1PE11.4)',END=1) dummy, Wert(i)
        end do

        i = 0
        do while (i.LT.nT)
          i = i + 1
          read(5,'(A27,1X,A10)',END=1) dummy, MS_Name(i)
          do j=1,11
            read(5,'(A27,1PE11.4)',END=1) dummy, SW(j,i)
          end do
        end do
    1   close(5)
        Wert(9) = 0.  ! C_0_laden immer aus
      end if

      END

************************************************************************
************************************************************************
*     Daten_speichern. Speichert einen Datensatz.
*     Wird aufgerufen in:
*        Menue_Datei
*        Start_Simulation
*        Programmende
************************************************************************

      Subroutine Daten_speichern(Titel,Wert,MS_Name,SW,Pfad,Name)

************************************************************************

      Include 'nT.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i, j               ! Laufvariable
      Integer*2      Status             ! Status des Dateinamens
      Integer*2      Anzahl_MS          ! # der aktiven Masterspezies
      Integer*2      Anzahl_MS_g        ! # der gesetzten Masterspezies
      Integer*2      MS(nT)             ! aktive Masterspezies

      Real           Wert(Anzahl)       ! Datenvektor 1
      Real           SW(11,nT)          ! Datenvektor 2

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*10   MS_Name(nT)        ! Masterspeziesnamen
      Character*27   PAR_Name(Anzahl)   ! Dummys
      Character*27   Dummy(12)          ! Dummys
      Character*37   Titel(2)           ! Datensatz-Titel
      Character*30   Pfad               ! Dateinpfad
      Character*12   Name               ! Dateiname
      Character*42   Filename           ! vollstndiger Dateiname
      Character*54   FTD                ! Filetitel
      Character*80   FT                 ! Filetitel

************************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FTD = 'CoTAM, allgemeine Parameter, erstellt am '//Datum//' um '
      FT  = FTD//Zeit

************************************************************************

      Status = 2
      call Maske_m('S_DAT')
      call Dateiname(25,7,Status,'\*.DAT',Pfad,Name)

      if (Status.NE.-1) then
        PAR_Name(1)  = 'Dichte                    :'
        PAR_Name(2)  = 'Porositt                 :'
        PAR_Name(3)  = 'Sulenlnge               :'
        PAR_Name(4)  = 'Abstandsgeschwindigkeit   :'
        PAR_Name(5)  = 'Dispersivitt             :'
        PAR_Name(6)  = 'Diffusionskoeffizient     :'
        PAR_Name(7)  = 't_max                     :'
        PAR_Name(8)  = 'dt                        :'
        PAR_Name(9)  = 'C_0_laden                 :'
        PAR_Name(10) = 'dt_num                    :'
        PAR_Name(11) = 'dx_num                    :'
        PAR_Name(12) = 't_analy                   :'
        PAR_Name(13) = 'Iter_max                  :'
        PAR_Name(14) = 'Epsilon                   :'
        PAR_Name(15) = 'Modelltyp (0/1)           :'

        Dummy(1)     = 'Tracer                    :'  ! Name
        Dummy(2)     = 'Tracer aktiv (1)          :'  ! SW(1,i)
        Dummy(3)     = 'Isotherme (1=H,2=F,3=L)   :'  ! SW(2,i)
        Dummy(4)     = 'C_input                   :'  ! SW(3,i)
        Dummy(5)     = 'Rate 1                    :'  ! SW(4,i)
        Dummy(6)     = 'P1                        :'  ! SW(5,i)
        Dummy(7)     = 'P2                        :'  ! SW(6,i)
        Dummy(8)     = 'Rate 2                    :'  ! SW(7,i)
        Dummy(9)     = 'P3                        :'  ! SW(8,i)
        Dummy(10)    = 'P4                        :'  ! SW(9,i)
        Dummy(11)    = 'Normierungsfaktor         :'  ! SW(10,i)
        Dummy(12)    = 'PHREEQE Element-Nr.       :'  ! SW(11,i)

        call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
        if (Anzahl_MS_g.EQ.0)  Anzahl_MS_g = 1

        call Verbinde_Pfad_Filename(Pfad,Name,Filename)
        open(unit=5,file=Filename)
        write(5,'(A)') FT
        write(5,'(A)') ' '
        write(5,'(A28,A37)') 'Titel 1                   : ', Titel(1)
        write(5,'(A28,A37)') 'Titel 2                   : ', Titel(2)
        do i=1, Anzahl
          write(5,'(A27,1PE11.4)') PAR_Name(i), Wert(i)
        end do
        do i=1,Anzahl_MS_g
          write(5,'(A27,1X,A10)') dummy(1), MS_Name(i)
          do j=1,11
            write(5,'(A27,1PE11.4)') dummy(j+1), SW(j,i)
          end do
        end do
        close(5)
      end if

      END

************************************************************************
************************************************************************
*     UMS_File_erstellen. Erstellt eine Umsatzraten-Datei mit Default-
*     Parametern.
*     Wird aufgerufen in:
*        Menue_Datei
************************************************************************

      Subroutine UMS_File_erstellen(Wert,SW,Anzahl_MS_g,
     *                              PAR_Pfad,PAR_File,
     *                              UMS_Pfad,UMS_File)

************************************************************************

      Include 'nmax.inc'
      Include 'nT.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i, l               ! Laufvariablen
      Integer*2      Status             ! Dateiname korrekt ?
      Integer*2      Anzahl_MS_g        ! # der gesetzten Masterspezies

      Real           Wert(Anzahl)       ! Datenvektor
      Real           SW(11,nT)          ! Datenvektor
      Real           X                  ! Ort
      Real           d(2)               ! Dummys

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*12   PAR_File           ! Dateiname
      Character*12   UMS_File           ! Dateiname
      Character*12   STO_File           ! Dateiname
      Character*30   PAR_Pfad           ! Dateipfad
      Character*30   UMS_Pfad           ! Dateipfad
      Character*42   Filename           ! vollstndiger Dateiname
      Character      Dummy              ! Dummy
      Character*47   FTD                ! Filetitel
      Character*80   FT                 ! Filetitel

************************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FT = ' CoTAM, Umsatzraten, erstellt am '//Datum//' um '//Zeit

*************************************************************************

      Status = 2
      call Maske_m('S_UMS')
      call Dateiname(25,7,Status,'\*.UMS',UMS_Pfad,UMS_File)

      if (Status.NE.-1) then
        call Verbinde_Pfad_Filename(UMS_Pfad,UMS_File,Filename)
        open(unit=5,file=Filename)
        write(5,'(A)') FT
        write(5,'(A)') ' '
        write(5,'(4X,A)') 'X      C/N     Umsatzraten'
        if (PAR_File.NE.'NONAME.PAR') then
          call Verbinde_Pfad_Filename(PAR_Pfad,PAR_File,Filename)
          open(unit=6,file=Filename)
          read(6,'(A)') Dummy
          read(6,'(A)') Dummy
          read(6,'(A)') Dummy
          X = 0.0
          do i=1, nmax ! n+2
            read(6,*,END=1) (d(j), j=1,2)
            X = X + d(2)  ! d(2) = dz
            write(5,'(F8.2,1X,F7.3,20(1X,F5.1))') X, 6.625,
     *           (0.0, l=1,Anzahl_MS_g)
          end do
    1     close(6)
        else
          n  = NINT(Wert(3)/Wert(11))
          X  = 0.0
          dz = Wert(11)
          do i=1, n+2
            X = X + dz
            write(5,'(F8.2,1X,F7.3,20(1X,F5.1))') X, 6.625,
     *           (0.0, l=1,Anzahl_MS_g)
          end do
        end if
        close(5)

        FTD = ' CoTAM, Stchiometrische Faktoren, erstellt am '
        FT  = FTD//Datum//' um '//Zeit
        STO_File = UMS_File
        call Setze_Extension(STO_File,'.STO')
        call Verbinde_Pfad_Filename(UMS_Pfad,STO_File,Filename)
        open(unit=5,file=Filename)
        write(5,'(A)') FT
        write(5,'(A)') ' '
        write(5,'(A)') ' Tracer  Stchiometrische Faktoren'
        write(5,'(I7,20(1X,I3))') 1,1,(0,l=2,20)
        write(5,'(I7,20(1X,I3))') 2,0,-1,0,0,1,1,(0,l=7,20)
        write(5,'(I7,20(1X,I3))') 3,0,0,0,-1,0,-1,(0,l=7,20)
        write(5,'(I7,20(1X,I3))') 4,(0,l=1,6),-1,(0,l=8,20)
        write(5,'(I7,20(1X,I3))') 5,(0,l=1,7),-1,(0,l=9,20)
        write(5,'(I7,20(1X,I3))') 6,(0,l=1,8),1,(0,l=10,20)
        write(5,'(I7,20(1X,I3))') 7,(0,l=1,8),-1,(0,l=10,20)
        write(5,'(I7,20(1X,I3))') 8,(0,l=1,9),-1,(0,l=11,20)
        write(5,'(I7,20(1X,I3))') 9,0,1,1,1,(0,l=5,20)
        write(5,'(I7,20(1X,I3))')10,(0,l=1,9),1,(0,l=11,20)
        write(5,'(I7,20(1X,I3))')11,4,2,6,10,4,8,4,3,9,9,(0,l=11,20)
        do i=12,20
          write(5,'(I7,20(1X,I3))') i,(0,l=1,20)
        end do
        close(5)
      end if

      END

***********************************************************************
***********************************************************************
*     PAR_File_erstellen. Erstellt eine variable Parameter-Datei mit
*     Default-Parametern.
*     Wird aufgerufen in:
*        Menue_Datei
***********************************************************************

      Subroutine PAR_File_erstellen(W,SW,Pfad,Name)

***********************************************************************

      Include 'nT.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i                  ! Laufvariable
      Integer*2      Status             ! Dateiname korrekt ?
      Integer*2      Anzahl_MS          ! # der aktiven Masterspezies
      Integer*2      Anzahl_MS_g        ! # der gesetzten Masterspezies
      Integer*2      MS(nT)             ! aktive Masterspezies

      Real           W(Anzahl)          ! Datenvektor
      Real           SW(11,nT)          ! Datenvektor 2 (Sorpwert)
      Real           Tiefe              ! Tiefe (Dummy)

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad
      Character*42   Filename           ! vollstndiger Dateiname
      Character*52   FTD                ! Filetitel
      Character*80   FT                 ! Filetitel

************************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FTD = ' CoTAM, variable Parameter, erstellt am '//Datum//' um '
      FT  = FTD//Zeit

*************************************************************************

      Status = 2
      call Maske_m('S_PAR')
      call Dateiname(25,7,Status,'\*.PAR',Pfad,Name)

      if (Status.NE.-1) then
*  PAR
        call Verbinde_Pfad_Filename(Pfad,Name,Filename)
        open(unit=5,file=Filename)
        n = NINT(W(3)/W(11))
        call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
        write(5,'(A)') FT
        write(5,'(A)') ' '
        if (W(15).LT.1.) then
        write(5,'(A)')  ' Tiefe       dx          Dichte      Porositt
     *  v_a         a_l         Diffusionskoeffizienten'
        else
        write(5,'(A)')  ' Tiefe       dx          Dichte      Porositt
     *  w           a_l         Diffusionskoeffizienten'
        end if
        Tiefe = W(11)/2.D0
        write(5,'(26(1PE11.4,1X))') Tiefe, W(11), W(1), W(2), W(4),
     *  W(5), (W(6), l=1,Anzahl_MS_g)
        do i=2, n+2
          Tiefe = Tiefe + W(11)
          write(5,'(26(1PE11.4,1X))') Tiefe, W(11), W(1), W(2), W(4),
     *    W(5), (W(6), l=1,Anzahl_MS_g)
        end do
        close(5)
      end if

      END

************************************************************************
************************************************************************
*     Messwerte_laden. Ldt die Messwerte aus einer Datei.
*     Wird aufgerufen in:
*        Main
*        Menue_Datei
************************************************************************

      Subroutine Messwerte_laden(Status,Messwert,Pfad,Name)

***********************************************************************

      integer*2      Anzahl_mess
      Parameter     (Anzahl_mess = 500)

      Integer*2      i                        ! Laufvariable
      Integer*2      n_MW                     ! # der Messwerte
      Integer*2      Status                   ! Dateistatus
      Integer*2      Format                   ! 1=EXP, 2=PRN

      real           Messwert(Anzahl_mess,4)  ! Messwerte

      Character*7    Dummy                    ! Dummy
      Character*12   Name                     ! Dateiname
      Character*30   Pfad                     ! Dateipfad
      Character*42   Filename                 ! vollstndiger Dateiname

*************************************************************************

      call Del_Mess(Messwert)

      if (Status.EQ.0) then  ! Filename ber Commandline gegeben
       Format = 1
       call Dateiname(25,7,Status,'\*.EXP',Pfad,Name)
      else
        Status = 1
        call Menue_m('EXP_File',Format)
        call Maske_o('NoMenue')
        if (Format.EQ.1) then
          call Maske_m('L_EXP')
          call Dateiname(25,7,Status,'\*.EXP',Pfad,Name)
        end if
        if (Format.EQ.2) then
          call Maske_m('L_PRN')
          call Dateiname(25,7,Status,'\*.PRN',Pfad,Name)
        end if
      end if

      if ((Status.NE.-1) .AND. (Format.GT.0)) then
        call Verbinde_Pfad_Filename(Pfad,Name,Filename)
        open(unit=5,file=Filename)
        if (Format.EQ.1) then
          read(5,'(A)',END=1) dummy   ! Messdaten
          read(5,'(A)',END=1) dummy   ! Leerzeile
          read(5,'(A)',END=1) dummy   ! Zeit ....
          n_MW = 1
        else
          n_MW = 2
        end if

        do while (n_MW.LT.Anzahl_mess)
          read(5,*,END=1) (Messwert(n_MW,i), i=1,4)
          n_MW = n_MW + 1
        end do
    1   close(5)

        n_MW = 2
        do while ((n_MW.LT.Anzahl_mess-1) .AND.
     *            (Messwert(n_MW,2).GT.-99999.))
          n_MW = n_MW + 1
        end do
        Messwert(1,1) = FLOAT(n_MW) - 2

        n_MW = 2
        do while ((n_MW.LT.Anzahl_mess-1) .AND.
     *            (Messwert(n_MW,4).GT.-99999.))
          n_MW = n_MW + 1
        end do
        Messwert(1,3) = FLOAT(n_MW) - 2
      end if

      END

************************************************************************
************************************************************************
*     Messwerte_speichern. Speichert die Messwerte in einer Datei.
*     Wird aufgerufen in:
*        Menue_Datei
************************************************************************

      Subroutine Messwerte_speichern(Messwert,Pfad,Name)

************************************************************************

      integer*2      Anzahl_mess
      Parameter     (Anzahl_mess = 500)

      Integer*2      i, j               ! Laufvariable
      Integer*2      n_MW               ! # der Messwerte
      Integer*2      Status             ! Dateistatus

      Real           Messwert(Anzahl_mess,4)  ! Messwerte

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad
      Character*42   Filename           ! vollstndiger Dateiname
      Character*60   FT                 ! Filetitel

************************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FT = ' CoTAM, Messdaten, erstellt am '//Datum//' um '//Zeit

************************************************************************

      Status = 2
      call Maske_m('S_EXP')
      call Dateiname(25,7,Status,'\*.EXP',Pfad,Name)

      if (Status.NE.-1) then
        call Verbinde_Pfad_Filename(Pfad,Name,Filename)
        open(unit=5,file=Filename)
        write(5,'(A)') FT
        write(5,'(A)') ' '
        write(5,'(A)') ' Zeit        C_mess      Ort         C_mess'
        n_MW = MAX0(NINT(Messwert(1,1)),NINT(Messwert(1,3)))
        do i=1, n_MW+1
          write(5,'(4(1PE11.4,1X))') (Messwert(i,j), j=1,4)
        end do
        close(5)
      end if

      END

************************************************************************
************************************************************************
*     C_O_setzen. Liest eine Hintergrundkonzentrationsdatei.
*     Wird aufgerufen in:
*        Simulation
************************************************************************

      Subroutine C_0_setzen(Plot,C_0_laden,
     *                      n,Anzahl_MS,dt,t,
     *                      C,S,
     *                      PRX_Pfad,PRX_File,
     *                      LPR_Pfad,LPR_File)

************************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      Integer*2       n_site
      Parameter      (n_site = 2)       ! Two-Site-Isotherme

      Integer*2      i, l               ! Laufvariablen
      Integer*2      Plot               ! Kontroll-Flag
      Integer*2      C_0_laden          ! PRX-File laden ?
      Integer*2      n                  ! # der Zellen
      Integer*2      Anzahl_MS          ! # der Masterspezies

      Real*8         C(nmax,nT)         ! Konzentration
      Real*8         S(nmax,n_site,nT)  ! sorbierte Konzentration
      Real*8         X, t               ! Ort und Zeit
      Real*8         dt                 ! Zeitschritt

      Character*10   Dummy              ! Dummy
      Character*10   MS_Name(nT)        ! Name der Tracer

      Character*12   PRX_File           ! Dateiname
      Character*12   LPR_File           ! Dateiname

      Character*30   PRX_Pfad           ! Pfad fr PRX-File
      Character*30   LPR_Pfad           ! Pfad fr LPR-File

      Character*42   Filename           ! vollstndiger Dateiname

************************************************************************

      if (C_0_laden.GE.1) then
        if (C_0_laden.EQ.1) then
          call Verbinde_Pfad_Filename(PRX_Pfad,PRX_File,Filename)
        else
          call Verbinde_Pfad_Filename(LPR_Pfad,LPR_File,Filename)
        end if

        if ((Plot.EQ.7) .OR. (Plot.EQ.9)) then
          call gotoxy(3,4)
          write(*,'(A,A,$)') 'C_0_File        : ', Filename
        end if

        open(unit=14,file=Filename)
        read(14,'(A)') Dummy      ! CoTAM, Sulenveteilung
        read(14,'(A)') Dummy      ! leer
        if (C_0_laden.EQ.1) then  ! PRX-File
          read(14,'(A7,1PE11.4)') Dummy, t
          do l=1,Anzahl_MS
            read(14,'(1X,A10)',END=1) Dummy ! leer
            read(14,'(1X,A10)',END=1) MS_Name(l)
            do i=1,n+2
              read(14,*,END=1) X, C(i,l), S(i,1,l), S(i,2,l)
              C(i,l)   = DBLE(C(i,l))
              S(i,1,l) = DBLE(S(i,1,l))
              S(i,2,l) = DBLE(S(i,2,l))
            end do
          end do
    1     close(14)
        else                      ! LPR-File
          read(14,'(A7,1PE11.4)') Dummy, t
          read(14,'(A)') Dummy    ! leer
          read(14,'(A)') Dummy    ! Tiefe, C(x,t)
          read(14,*,END=2) X, (C(1,l), l=1,Anzahl_MS)  ! X = 0
          do i=1,n+2
            read(14,*,END=2) X, (C(i,l), l=1,Anzahl_MS)
            do l=1,Anzahl_MS
              C(i,l)   = DBLE(C(i,l))
              S(i,1,l) = 0.D0
              S(i,2,l) = 0.D0
            end do
          end do
    2     close(14)
        end if
      else
        t = dt
        do l=1,Anzahl_MS
          do i=1,n+2
            C(i,l)   = 0.D0
            S(i,1,l) = 0.D0
            S(i,2,l) = 0.D0
          end do
        end do
      end if

      END

************************************************************************
************************************************************************
*     Setze_Pfade. Lies INI-Datei und setzt die Pfade entsprechend.
*     Wird aufgerufen in:
*        Main
*        Menue_System
************************************************************************

      Subroutine Setze_Pfade(Aufruf,                         ! wer ruft
     *                       DAT_Pfad,DAT_File,              ! DAT
     *                       PAR_Pfad,PAR_File,              ! PAR
     *                       UMS_Pfad,UMS_File,              ! KIN
     *                       PHR_Pfad,PHR_File,              ! PHR
     *                       EXP_Pfad,EXP_File,              ! EXP
     *                       PRN_Pfad,PRN_File,              ! PRN
     *                       PRX_Pfad,PRX_File,              ! PRX
     *                       PRX_File_neu,                   ! PRX
     *                       LPR_Pfad,LPR_File)              ! LPR

***********************************************************************

      Integer*2      Status              ! Kontrollflag
      Integer*2      Aufruf              ! Kontrollflag
      Integer*2      i                   ! Laufvariable
      Integer*2      DE(10)              ! DOS Error

      Character*12   INI_File            ! Dateiname
      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   INI_Pfad            ! Pfad fr INI-File
      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File

      Character*42   Filename            ! Dateiname, Dummy

************************************************************************

      call Dateipfad(INI_Pfad,INI_File,'\*.INI')
      call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      call Zerlege_Pfad_Filename(Filename,INI_Pfad,INI_File)

      if (Aufruf.EQ.0) then
        Status   = 0
        INI_File = 'COTAM.INI'
        call Dateiname(25,7,Status,'\*.INI',INI_Pfad,INI_File)
        call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      end if
      if (Aufruf.EQ.1) then
        Status   = 1
        INI_File = 'NONAME.INI'
        call Maske_m('L_INI')
        call Dateiname(25,7,Status,'\*.INI',INI_Pfad,INI_File)
        call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      end if

      if (Status.NE.-1) then
        open(unit=5,file=Filename)
        read(5,'(A)',ERR=1) Filename  ! Nur als Dummy
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,DAT_Pfad,DAT_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PAR_Pfad,PAR_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,UMS_Pfad,UMS_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PHR_Pfad,PHR_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,EXP_Pfad,EXP_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PRN_Pfad,PRN_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PRX_Pfad,PRX_File)
        read(5,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,LPR_Pfad,LPR_File)
  1     close(5)
      else
        call Dateipfad(DAT_Pfad,DAT_File,'\*.DAT')
        call Dateipfad(PAR_Pfad,PAR_File,'\*.PAR')
        call Dateipfad(UMS_Pfad,UMS_File,'\*.UMS')
        call Dateipfad(PHR_Pfad,PHR_File,'\*.PHR')
        call Dateipfad(EXP_Pfad,EXP_File,'\*.EXP')
        call Dateipfad(PRN_Pfad,PRN_File,'\*.PRN')
        call Dateipfad(PRX_Pfad,PRX_File,'\*.PRX')
        call Dateipfad(LPR_Pfad,LPR_File,'\*.LPR')
        DAT_File     = 'NONAME.DAT'  ! Kein Name eingegeben
        PAR_File     = 'NONAME.PAR'  ! Kein Name eingegeben
        UMS_File     = 'NONAME.UMS'  ! Kein Name eingegeben
        PHR_File     = 'NONAME.PHR'  ! Kein Name eingegeben
        EXP_File     = 'NONAME.EXP'  ! Kein Name eingegeben
        PRN_File     = 'NONAME.PRN'  ! Kein Name eingegeben
        PRX_File     = 'NONAME.PRX'  ! Kein Name eingegeben
        PRX_File_neu = 'NONAME.PRX'  ! Kein Name eingegeben
        LPR_File     = 'NONAME.LPR'  ! kein Name eingegeben
      end if

      call Lege_Verzeichnis_an(DAT_Pfad,DE(1))
      call Lege_Verzeichnis_an(PAR_Pfad,DE(2))
      call Lege_Verzeichnis_an(UMS_Pfad,DE(3))
      call Lege_Verzeichnis_an(PHR_Pfad,DE(4))
      call Lege_Verzeichnis_an(EXP_Pfad,DE(5))
      call Lege_Verzeichnis_an(PRN_Pfad,DE(6))
      call Lege_Verzeichnis_an(PRX_Pfad,DE(7))
      call Lege_Verzeichnis_an(LPR_Pfad,DE(8))

      if (Aufruf.LE.1) then
        do i=1,8
          if (DE(i).EQ.3) then
            call cls
            write(*,'(A)') ' Pfade knnen nicht angelegt werden !'
            write(*,'(A)') ' berprfen Sie bitte die Datei COTAM.INI.'
            call Taste
          end if
        end do
      end if

      END

************************************************************************
************************************************************************
*     Schreibe_INI_File. Speichert INI-Datei.
*     Wird aufgerufen in:
*        Programmende
*        Menue_System
************************************************************************

      Subroutine Schreibe_INI_File(Aufruf,                 ! wer ruft ?
     *                             DAT_Pfad,DAT_File,      ! DAT
     *                             PAR_Pfad,PAR_File,      ! PAR
     *                             UMS_Pfad,UMS_File,      ! KIN
     *                             PHR_Pfad,PHR_File,      ! PHR
     *                             EXP_Pfad,EXP_File,      ! EXP
     *                             PRN_Pfad,PRN_File,      ! PRN
     *                             PRX_Pfad,PRX_File,      ! PRX
     *                             LPR_Pfad,LPR_File)      ! LPR

************************************************************************

      Integer*2      Aufruf              ! wer ruft ?
      Integer*2      Status              ! Dateistatus

      Character*12   INI_File            ! Dateiname
      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   INI_Pfad            ! Pfad fr INI-File
      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File

      Character*42   Filename            ! Dummy

***********************************************************************

      call Dateipfad(INI_Pfad,INI_File,'\*.INI')
      call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      call Zerlege_Pfad_Filename(Filename,INI_Pfad,INI_File)

      if (Aufruf.EQ.1) then
        Status   = 2
        INI_File = 'NONAME.INI'
        call Maske_m('S_INI')
        call Dateiname(25,7,Status,'\*.INI',INI_Pfad,INI_File)
        call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      else
        Status = 0
        INI_File = 'COTAM.INI'
        call Verbinde_Pfad_Filename(INI_Pfad,INI_File,Filename)
      end if

      if (Status.NE.-1) then
        open(unit=5,file=Filename)
        write(5,'(A)') 'CoTAM-Initialisierung'
        call Verbinde_Pfad_Filename(DAT_Pfad,DAT_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(PAR_Pfad,PAR_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(UMS_Pfad,UMS_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(PHR_Pfad,PHR_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(EXP_Pfad,EXP_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(PRN_Pfad,PRN_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(PRX_Pfad,PRX_File,Filename)
        write(5,'(A)') Filename
        call Verbinde_Pfad_Filename(LPR_Pfad,LPR_File,Filename)
        write(5,'(A)') Filename
        close(5)
      end if

      END

***********************************************************************
***********************************************************************
*     LPR_Filename. Dialog zur Eingabe des Filenamens
*     Wird aufgerufen in:
*        Menue_Zeit
***********************************************************************

      Subroutine LPR_Filename(Pfad,Name)

      Integer*2      Status             ! Dateistatus
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad

***********************************************************************

      Status = 1
      call Maske_m('L_LPR')
      call Dateiname(25,7,Status,'\*.LPR',Pfad,Name)
      if (Status.EQ.-1) Name = 'NONAME.LPR'

      END

***********************************************************************
***********************************************************************
*     UMS_Filename. Dialog zur Eingabe des Filenamens
*     Wird aufgerufen in:
*        Menue_Datei
***********************************************************************

      Subroutine UMS_Filename(Pfad,Name)

      Integer*2      Status             ! Dateistatus
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad

***********************************************************************

      Status = 1
      call Maske_m('L_UMS')
      call Dateiname(25,7,Status,'\*.UMS',Pfad,Name)
      if (Status.EQ.-1) Name = 'NONAME.UMS'

      END

***********************************************************************
***********************************************************************
*     PHR_Filename. Dialog zur Eingabe des Filenamens
*     Wird aufgerufen in:
*        Menue_Datei
***********************************************************************

      Subroutine PHR_Filename(Pfad,Name)

      Integer*2      Status             ! Dateistatus
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad

***********************************************************************

      Status = 1
      call Maske_m('L_PHR')
      call Dateiname(25,7,Status,'\*.PHR',Pfad,Name)
      if (Status.EQ.-1) Name = 'NONAME.PHR'

      END

***********************************************************************
***********************************************************************
*     PAR_Filename. Dialog zur Eingabe des Filenamens
*     Wird aufgerufen in:
*        Menue_Datei
***********************************************************************

      Subroutine PAR_Filename(Pfad,Name)

      Integer*2      Status             ! Dateistatus
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad

***********************************************************************

      Status = 1
      call Maske_m('L_PAR')
      call Dateiname(25,7,Status,'\*.PAR',Pfad,Name)
      If (Status.EQ.-1) Name = 'NONAME.PAR'

      END

***********************************************************************
***********************************************************************
*     PRX_Filename. Dialog zur Eingabe des Filenamens
*     Wird aufgerufen in:
*        Menue_Zeit
*        Export_PRX_to_LOTUS
***********************************************************************

      Subroutine PRX_Filename(Pfad,Name)

      Integer*2      Status             ! Datenformat
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Dateipfad

***********************************************************************

      Status = 1
      call Maske_m('L_PRX')
      call Dateiname(25,7,Status,'\*.PRX',Pfad,Name)
      if (Status.EQ.-1) Name = 'NONAME.PRX'

      END


***********************************************************************
***********************************************************************
*     UMS_Daten_laden. Liest den Umsatzraten-Datensatz.
*     Wird aufgerufen in:
*        Simulation
***********************************************************************

      Subroutine UMS_Daten_laden(Typ,n,Anzahl_MS,Stoech,UR,CNV,
     *                           UMS_Pfad,UMS_File,PAR_Pfad,PAR_File)

***********************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      Integer*2       nK
      Parameter      (nK     = nT)    ! Anzahl der kineti. Konstanten

      Integer*2      i, l, k          ! Laufvariablen
      Integer*2      n                ! # der Zellen
      Integer*2      Anzahl_MS        ! # der aktiven Masterspezies
      Integer*2      Status           ! Datensatz existent
      Integer*2      Tracer           ! Dummy

      Real           X                ! Ort (Dummy)
      Real           Typ              ! GW oder Sediment
      Real           vW(25)           ! variable Parameter
      Real           Tiefe            ! Dummy

      Real*8         Stoech(nT,nK)    ! Stchometrische Faktoren
      Real*8         UR(nmax,nK)      ! Umsatzraten
      Real*8         CNV(nmax)        ! C/N-Verhltnis

      Character      Dummy            ! Dummy

      Character*12   UMS_File         ! Dateiname
      Character*12   PAR_File         ! Dateiname
      Character*12   STO_File         ! Dateiname
      Character*30   UMS_Pfad         ! Dateipfad
      Character*30   PAR_Pfad         ! Dateipfad

      Character*42   Filename_UMS     ! vollstndiger Dateiname
      Character*42   Filename_PAR     ! vollstndiger Dateiname
      Character*42   Filename_STO     ! vollstndiger Dateiname

      Logical        Existent_UMS     ! Existiert die Datei ?
      Logical        Existent_PAR     ! Existiert die Datei ?
      Logical        Existent_STO     ! Existiert die Datei ?

***********************************************************************

      do i=1,n+2
        do k=1,Anzahl_MS
          UR(i,k) = 0.D0
        end do
      end do
      do l=1,nT
        do k=1,nK
          Stoech(l,k) = 0.D0
        end do
      end do

***********************************************************************

      if (UMS_File.NE.'NONAME.UMS') then
        Status   = 0
        STO_File = UMS_File
        call Setze_Extension(STO_File,'.STO')
        call Verbinde_Pfad_Filename(UMS_Pfad,STO_File,Filename_STO)
        call Verbinde_Pfad_Filename(UMS_Pfad,UMS_File,Filename_UMS)
        inquire(File=Filename_STO, Exist=Existent_STO)
        inquire(File=Filename_UMS, Exist=Existent_UMS)
        if ((.NOT.Existent_UMS) .OR. (.NOT.Existent_STO)) Status = -1
      else
        Status = -1
      end if

      if (Status.NE.-1) then
        open(unit=5,file=Filename_UMS)  ! Umsatzraten lesen
        do i=1,3
          read(5,'(A)') dummy
        end do
        do i=1,n+2
          read(5,*) X, CNV(i), (UR(i,k), k=1,Anzahl_MS)
        end do
        close(5)

        if ((PAR_File.NE.'NONAME.PAR') .AND. (Typ.GE.1.)) then
          call Verbinde_Pfad_Filename(PAR_Pfad,PAR_File,Filename_PAR)
          inquire(File=Filename_PAR, Exist=Existent_PAR)
          if (Existent_PAR) then
            open(unit=5,file=Filename_PAR)
            read(5,'(A)') dummy
            read(5,'(A)') dummy
            read(5,'(A)') dummy
            do i=1,n+2
              read(5,*,END=1) Tiefe, (vW(l), l=1,5+Anzahl_MS)
              do k=1,Anzahl_MS
                UR(i,k) = UR(i,k) * DBLE(vW(3))
              end do
            end do
    1      close(5)
          end if
        end if

        open(unit=5,file=Filename_STO)  ! Stchiometrische Faktoren
        do i=1,3
          read(5,'(A)') dummy
        end do
        do l=1,nT
          read(5,*) Tracer, (Stoech(l,k), k=1,nK)
        end do
        close(5)
      end if

      END

***********************************************************************
***********************************************************************
*     Speicher_PRX. Speichert die Sulenverteilung am Ende der
*     Simulation.
*     Wird aufgerufen in:
*        Simulation
***********************************************************************

      Subroutine Speicher_PRX(Plot,n,Anzahl_MS,t,dx,MS_Name,C,S,
     *                        Pfad,Name)

***********************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      Integer*2       n_site
      Parameter      (n_site = 2)       ! Two-Site-Isotherme

      Integer*2      i, l               ! Laufvariablen
      Integer*2      n                  ! # der REV
      Integer*2      Anzahl_MS          ! # der Tracer
      Integer*2      Plot               ! Kontroll-Flag

      Real*8         C(nmax,nT)         ! Konzentration
      Real*8         S(nmax,n_site,nT)  ! sorbierte Konzentration
      Real*8         dx(nmax), X, t     ! Ort und Zeit (Dummys)

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*10   MS_Name(nT)        ! Name der Tracer
      Character*12   Name               ! Dateiname
      Character*30   Pfad               ! Pfad fr PRX-File
      Character*42   Filename           ! Dateiname
      Character*60   FT                 ! Filetitel

***********************************************************************
*     aktuelles Datum und Zeit ermitteln
      call Datum_Zeit_ermitteln(Datum,Zeit)
      FT = 'CoTAM, Sulenverteilung, erstellt am '//Datum//' um '//Zeit

***********************************************************************

      call Verbinde_Pfad_Filename(Pfad,Name,Filename)
      if (Plot.GE.8) then
        call gotoxy(3,6)
        write(*,'(A,A,$)') 'Konz. in Sule  : ', Filename
      end if
      open(unit=13,file=Filename)
      write(13,'(A)') FT
      write(13,'(A)') ' '
      write (13,'(A,1PE11.4)') 'Zeit :',t
      do l=1,Anzahl_MS
        write (13,'(A10)') '         '
        write (13,'(A10)') MS_Name(l)
        X = 0.D0
        do i=1,n+2
          if (C(i,l).LT.1.D-50)   C(i,l)   = 0.D0
          if (S(i,1,l).LT.1.D-50) S(i,1,l) = 0.D0
          if (S(i,2,l).LT.1.D-50) S(i,2,l) = 0.D0
          if (i.EQ.1) then
            X = dx(1)/2.D0
          else
            X = X + dx(i-1)/2.D0 + dx(i)/2.D0
          end if
          write (13,'(4(1X,1PE14.5))') X, C(i,l), S(i,1,l), S(i,2,l)
        end do
      end do
      close(13)

      END

***********************************************************************
***********************************************************************
*     Export_PRX_to_LOTUS. Liest einen PRX_File und speichert ihn als
*     LPR-File wieder ab.
*     Wird aufgerufen in:
*        Menue_Datei
***********************************************************************

      Subroutine Export_PRX_to_LOTUS(W,SW,
     *                               PRX_Pfad,PRX_File,
     *                               LPR_Pfad,LPR_File)

***********************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      Integer*2       n_site, Anzahl
      Parameter      (n_site = 2)       ! Two-Site-Isotherme
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i, l               ! Laufvariablen
      Integer*2      Status             ! Dateiname korrekt ?
      Integer*2      n                  ! # der Zellen
      Integer*2      Anzahl_MS          ! # der aktiven Masterspezies
      Integer*2      Anzahl_MS_g        ! # der gesetzten Masterspezies
      Integer*2      MS(nT)             ! aktive Masterspezies

      Real           W(Anzahl)          ! Datenvektor
      Real           SW(11,nT)          ! Datenvektor 2 (Sorpwert)
      Real*8         C(nmax,nT)         ! Konzentration
      Real*8         S(nmax,n_site,nT)  ! sorbierte Konzentration
      Real*8         X(nmax)            ! Ort (Tiefe)
      Real*8         t                  ! Zeit (Dummys)

      Character*8    Datum              ! Datum beim ffnen des Files
      Character*8    Zeit               ! Zeit beim ffnen des Files
      Character*10   Dummy              ! Dummy
      Character*10   MS_Name(nT)        ! Name der Tracer
      Character*12   PRX_File           ! Dateiname
      Character*12   LPR_File           ! Dateiname
      Character*30   PRX_Pfad           ! Dateipfad
      Character*30   LPR_Pfad           ! Dateipfad
      Character*42   Filename           ! vollstndiger Dateiname
      Character*46   FTD                ! Filetitel
      Character*100  FT                 ! Filetitel

***********************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FTD = ' CoTAM, Konzentrationsverteilungen in Lsung, '
      FT  = FTD//'erstellt am '//Datum//' um '//Zeit

***********************************************************************

      Status = 2
      call PRX_Filename(PRX_Pfad,PRX_File)
      if (PRX_File.EQ.'NONAME.PRX') Status = -1

      if (Status.NE.-1) then
        call Maske_m('S_LPR')
        call Dateiname(25,7,Status,'\*.LPR',LPR_Pfad,LPR_File)
      end if

      if (Status.NE.-1) then
        n = NINT(W(3)/W(11))
        call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
        call Verbinde_Pfad_Filename(PRX_Pfad,PRX_File,Filename)
        open(unit=14,file=Filename)
        read(14,'(A)') Dummy
        read(14,'(A)') Dummy
        read(14,'(A7,1PE11.4)') Dummy, t
        do l=1,Anzahl_MS_g
          read(14,'(1X,A10)',END=1) Dummy
          read(14,'(1X,A10)',END=1) MS_Name(l)
          do i=1,n+2
            read(14,*,END=1) X(i), C(i,l), S(i,1,l), S(i,2,l)
          end do
        end do
    1   close(14)

        call Verbinde_Pfad_Filename(LPR_Pfad,LPR_File,Filename)
        open(unit=15,file=Filename)
        write(15,'(A)') FT
        write(15,'(A)') ' '
        write(15,'(A,1PE11.4)') ' Zeit :', t
        write(15,'(A)') ' '
        write(15,'(A)') ' Tiefe       C(x,t)'
        write(15,'(21(1PE11.4,1X))') 0.0, (SW(3,l), l=1,Anzahl_MS)
        do i=1,n+2
          write(15,'(21(1PE11.4,1X))') X(i), (C(i,l), l=1,Anzahl_MS)
        end do
        close(15)
      end if

      END

***********************************************************************
***********************************************************************
*     Ausgabefile. ffnet den PRN-Ausgabefile und schreibt den Kopf.
*     Wird aufgerufen in:
*        Simulation
***********************************************************************

      Subroutine Ausgabefile(Plot,Titel,
     *                       DAT_Pfad,DAT_File,
     *                       PRN_Pfad,PRN_File)

***********************************************************************

      Integer*2       Plot              ! Kontroll-Flag

      Character*8     Datum             ! Datum beim ffnen des Files
      Character*8     Zeit              ! Zeit beim ffnen des Files
      Character*37    Titel(2)          ! Titel des Datensatzes
      Character*12    DAT_File          ! Dateiname
      Character*12    PRN_File          ! Dateiname
      Character*30    DAT_Pfad          ! Pfad fr DAT-File
      Character*30    PRN_Pfad          ! Pfad fr PRN-File
      Character*42    DAT_Filename      ! Dateiname
      Character*42    PRN_Filename      ! Dateiname
      Character*60    FT                ! Filetitel

***********************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FT = 'CoTAM, Durchgangskurve, erstellt am '//Datum//' um '//Zeit

***********************************************************************
*     Ausgabefile ffnen

      call Verbinde_Pfad_Filename(DAT_Pfad,DAT_File,DAT_Filename)
      call Verbinde_Pfad_Filename(PRN_Pfad,PRN_File,PRN_Filename)
      if ((Plot.EQ.7) .OR. (Plot.EQ.9)) then
        call gotoxy(3,3)
        write(*,'(A,A)')   'Datei           : ', DAT_Filename
        call gotoxy(3,5)
        write(*,'(A,A,$)') 'Durchgangskurve : ', PRN_Filename
      end if
      open(unit=11,file=PRN_Filename)

***********************************************************************
*     Eingabedaten werden in den Ausgabefile geschrieben

      write (11,'(A)')    FT
      write (11,'(A)')    '  '
      write (11,'(A)')    Titel(1)
      write (11,'(A)')    Titel(2)
      write (11,'(A)')    '  '
      write (11,'(4X,A)') 'Zeit    PV      C(X,t)   C_rel'

      END



