************************************************************************
*                                                                      *
*    Datei                                                             *
*      TriDiag.for                                                     *
*                                                                      *
*    Inhalt                                                            *
*      Gleichungssystemlser fr tridiagonale Gleichungssysteme.       *
*      Entnommen dem Programm DISPER von Flhler und Jury (1982).      *
*      Speicherstruktur verndert (Press et al., 1992).                *
*      Neue Randbedingung am Ende des Sule.                           *
*      Wird aufgerufen in:                                             *
*         Simulation                                                   *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************

      Subroutine TRIDIAG(Rand,n,l,Abweichung,A,B,C)

************************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      Integer*2      i, l, n            ! Laufvariablen
      Integer*2      Rand               ! Typ der Randbedingung

      Real*8         Abweichung         ! Summe der Abweichungsquadrate
      Real*8         Nenner             ! Dummy
      Real*8         E(nmax), H(nmax)   ! Dummys

      Real*8         A(nmax,3,nT)       ! Koeffizientenmatrix
      Real*8         B(nmax)            ! Inhomogenitt
      Real*8         C(nmax,nT)         ! Konzentration

************************************************************************

      h(1) =  b(1)/a(1,2,l)
      e(1) = -a(1,3,l)/a(1,2,l)

      do i=2,n+1
        Nenner =  a(i,2,l) + a(i,1,l)*e(i-1)
        e(i)   = -a(i,3,l)/Nenner
        h(i)   = (b(i) - a(i,1,l)*h(i-1))/Nenner
      end do

      if (Rand.EQ.1) then
        Nenner = 1.D0 - e(n+1)*(2.D0 - e(n))
        h(n+2) = (b(n+2) + h(n+1)*(2.D0 - e(n)) - h(n))/Nenner
      else
        Nenner = 1.D0 - e(n+1)*e(n)
        h(n+2) = (b(n+2) + h(n) + h(n+1)*e(n))/Nenner
      end if

      C(n+2,l) = C(n+2,l) - h(n+2)
      do i=n+1,1,-1
        h(i)       = h(i) + e(i)*h(i+1)
        C(i,l)     = C(i,l) - h(i)
      end do

      Abweichung = 0.D0
      do i=1,n+2
        Abweichung = Abweichung + h(i)*h(i)
      end do

      END
