************************************************************************
*                                                                      *
*    Datei                                                             *
*      Workfile.for                                                    *
*                                                                      *
*    Inhalt                                                            *
*      Save_Workfile. Speichert alle Daten des aktuellen Zustands ab.  *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Start_Simulation                                             *
*                                                                      *
*      Load_Workfile. Ldt alle Daten des aktuellen Zustands aus der   *
*      Datei COTAM.WRK                                                 *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Simulation                                                   *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************

      Subroutine Save_Workfile(Plot,Menue,Waits,       ! Kontroll-Flag
     *                         Messwerte,              ! Messwerte
     *                         Titel,Wert,MS_Name,SW,  ! Daten
     *                         DAT_Pfad,DAT_File,      ! DAT
     *                         PAR_Pfad,PAR_File,      ! PAR
     *                         UMS_Pfad,UMS_File,      ! UMS
     *                         PHR_Pfad,PHR_File,      ! PHR
     *                         EXP_Pfad,EXP_File,      ! EXP
     *                         PRN_Pfad,PRN_File,      ! PRN
     *                         PRX_Pfad,PRX_File,      ! PRX
     *                         PRX_File_neu,           ! PRX
     *                         LPR_Pfad,LPR_File)      ! LPR

************************************************************************

      Include 'nt.inc'

      Integer*2       Anzahl
      Integer*2       Anzahl_mess
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter
      Parameter      (Anzahl_mess = 500) ! max. # der Messwerte

************************************************************************

      Integer*2      i, j                ! Laufvariablen
      Integer*2      Plot                ! Sollen geplottet werden ?
      Integer*2      n_MW                ! # der Messwerte
      Integer*2      Anzahl_MS           ! # aktiven Masterspezies
      Integer*2      Anzahl_MS_g         ! # der gesetzten Masterspezies
      Integer*2      MS(nT)              ! aktive Masterspezies
      Integer*2      Waits               ! Warteschleife

      Real           SW(11,nT)           ! Sorptionsparameter
      Real           Wert(Anzahl)        ! Datenvektor
      Real           Messwerte(Anzahl_mess,4) ! Messwerte

      Character*10   MS_Name(nT)         ! Namen der Masterspezies
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr LPR-File

      Character*42   Filename            ! Dateiname

      Character*8    Datum               ! Datum beim ffnen des Files
      Character*8    Zeit                ! Zeit beim ffnen des Files
      Character*80   FT                  ! Filetitel

      Logical        Menue               ! Men gewnscht

************************************************************************
*     aktuelles Datum und Zeit ermitteln

      call Datum_Zeit_ermitteln(Datum,Zeit)
      FT = 'CoTAM, Arbeitsdatei, erstellt am '//Datum//' um '//Zeit

************************************************************************
*     # Tracer, # Messwerte

      call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
      if (Anzahl_MS_g.EQ.0)  Anzahl_MS_g = 1

      n_MW = MAX0(NINT(Messwerte(1,1)),NINT(Messwerte(1,3)))
      if (n_MW.GT.Anzahl_mess)  n_MW = Anzahl_mess

************************************************************************

      Filename = 'COTAM.WRK'

      open(unit=7,file=Filename)

************************************************************************
*     Titel

      write(7,'(A)') FT
      write(7,'(A)') ' '
      write(7,'(A37)') Titel(1)
      write(7,'(A37)') Titel(2)
      write(7,'(A)') ' '

************************************************************************
*     Dateipfade und Dateinamen

      write(7,'(A)') 'Dateipfade und Dateinamen'
      call Verbinde_Pfad_Filename(DAT_Pfad,DAT_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(PAR_Pfad,PAR_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(UMS_Pfad,UMS_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(PHR_Pfad,PHR_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(EXP_Pfad,EXP_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(PRN_Pfad,PRN_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(PRX_Pfad,PRX_File,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(PRX_Pfad,PRX_File_neu,Filename)
      write(7,'(A)') Filename
      call Verbinde_Pfad_Filename(LPR_Pfad,LPR_File,Filename)
      write(7,'(A)') Filename
      write(7,'(A)') ' '

************************************************************************
*     Bildschirmdarstellung

      i = 0
      if (Menue) i = 1

      write(7,'(A)') 'Bildschirmdarstellung'
      write(7,'(I2,1X,I2,1X,I2)') Plot, i, Waits
      write(7,'(A)') ' '

************************************************************************
*     Daten des DAT-Files

      write(7,'(A)') 'DAT-File'
      write(7,'(I2)') Anzahl_MS_g
      write(7,'(7(1PE11.4,1X))') (Wert(i), i=1,5)
      write(7,'(7(1PE11.4,1X))') (Wert(i), i=6,10)
      write(7,'(4(1PE11.4,1X))') (Wert(i), i=11,Anzahl)
      do i=1,Anzahl_MS_g
        write(7,'(A10)') MS_Name(i)
        write(7,'(6(1PE11.4,1X))') (SW(j,i), j=1,6)
        write(7,'(5(1PE11.4,1X))') (SW(j,i), j=7,11)
      end do
      write(7,'(A)') ' '

************************************************************************
*     Messewerte

      write(7,'(A)') 'Messwerte'
      do i=1, n_MW+1
        write(7,'(4(1PE11.4,1X))') (Messwerte(i,j), j=1,4)
      end do

***********************************************************************

      close(7)

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Load_Workfile(Status,Plot,Menue,Waits, ! Kontroll-Flags
     *                         Messwerte,               ! Messwerte
     *                         Titel,Wert,MS_Name,SW,   ! Daten
     *                         DAT_Pfad,DAT_File,       ! DAT
     *                         PAR_Pfad,PAR_File,       ! PAR
     *                         UMS_Pfad,UMS_File,       ! UMS
     *                         PHR_Pfad,PHR_File,       ! PHR
     *                         PRN_Pfad,PRN_File,       ! PRN
     *                         PRX_Pfad,PRX_File,       ! PRX
     *                         PRX_File_neu,            ! PRX
     *                         LPR_Pfad,LPR_File)       ! LPR

************************************************************************

      Include 'nt.inc'

      Integer*2       Anzahl
      Integer*2       Anzahl_mess
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter
      Parameter      (Anzahl_mess = 500) ! max. # der Messwerte

************************************************************************

      Integer*2      i, j                ! Laufvariablen
      Integer*2      Plot                ! Sollen geplottet werden ?
      Integer*2      Status              ! Existiert Datei ?
      Integer*2      n_MW                ! # der Messwerte
      Integer*2      Anzahl_MS_g         ! # der gesetzten Masterspezies
      Integer*2      Waits               ! Warteschleife

      Real           SW(11,nT)           ! Sorptionsparameter
      Real           Wert(Anzahl)        ! Datenvektor
      Real           Messwerte(Anzahl_mess,4) ! Messwerte

      Character*10   MS_Name(nT)         ! Namen der Masterspezies
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   WRK_File            ! Dateiname
      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr LPR-File

      Character*42   Filename            ! Dummy

      Character*80   Dummy               ! Dummy

      Logical        Existent            ! Existiert die Datei ?
      Logical        Menue               ! Men gewnscht ?

************************************************************************
*     Initalisieren der Vektoren

      Status = -1
      Plot   = 9              ! CoTAM im Batch-Modus
      Menue  = .false.        ! keine Men gewnscht
      Waits  = 0              ! Keine Warteschleife

      do i=1,Anzahl
        Wert(i) = 0.          ! allgemeine Parameter
      end do
      Wert(9)  = 0.           ! C_0 wird nicht geladen
      Wert(10) = 0.0          ! dt_num
      Wert(11) = 0.0          ! dx_num
      Wert(12) = 0.0          ! t_analy
      Wert(13) = 12.          ! Iter_max
      Wert(14) = 1.E-10       ! Epsilon
      Wert(15) = 0.0          ! Grundwasser

      do i=1,nT
        MS_Name(i) = ' '      ! Name der Masterspezies
        do j=1,11
          SW(j,i) = 0.0       ! Isothermen-Parameter
        end do
        SW(2,i)  = 1.0        ! Henry-Isotherme voreingestellt
      end do

      Messwerte(1,1) = 0.0    ! erstmal keine Messwerte
      Messwerte(1,2) = 0.0    ! Normierung = 0
      Messwerte(1,3) = 0.0    ! erstmal keine Messwerte
      Messwerte(1,4) = 0.0    ! Normierung = 0
      do i=2,Anzahl_mess
        do j=1,4
          Messwerte(i,j) = -99999.
        end do
      end do

************************************************************************

      WRK_File = 'COTAM.WRK'
      inquire(File=WRK_File, Exist=Existent)

      if (Existent) then
        open(unit=7,file=WRK_File)

************************************************************************
*     Titel

        read(7,'(A)',ERR=1) Dummy
        read(7,'(A)',ERR=1) Dummy
        read(7,'(A37)',ERR=1) Titel(1)
        read(7,'(A37)',ERR=1) Titel(2)
        read(7,'(A)',ERR=1) Dummy

************************************************************************
*     Dateipfade und Dateinamen

        read(7,'(A)',ERR=1) Dummy
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,DAT_Pfad,DAT_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PAR_Pfad,PAR_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,UMS_Pfad,UMS_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PHR_Pfad,PHR_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,EXP_Pfad,EXP_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PRN_Pfad,PRN_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PRX_Pfad,PRX_File)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,PRX_Pfad,PRX_File_neu)
        read(7,'(A)',ERR=1) Filename
        call Zerlege_Pfad_Filename(Filename,LPR_Pfad,LPR_File)
        read(7,'(A)') Dummy

************************************************************************
*     Bildschirmdarstellung

        read(7,'(A)',ERR=1) Dummy
        read(7,*,ERR=1) Plot, i, Waits
        read(7,'(A)',ERR=1) Dummy

        if (i.EQ.1)  Menue = .true.

************************************************************************
*     Daten des DAT-Files

        read(7,'(A)',ERR=1) Dummy
        read(7,*,ERR=1) Anzahl_MS_g
        read(7,*,ERR=1) (Wert(i), i=1,5)
        read(7,*,ERR=1) (Wert(i), i=6,10)
        read(7,*,ERR=1) (Wert(i), i=11,Anzahl)
        do i=1,Anzahl_MS_g
          read(7,'(A10)',ERR=1) MS_Name(i)
          read(7,*,ERR=1) (SW(j,i), j=1,6)
          read(7,*,ERR=1) (SW(j,i), j=7,11)
        end do
        read(7,'(A)',ERR=1) Dummy

************************************************************************
*     Messewerte

        read(7,'(A)',ERR=1) Dummy
        read(7,*,ERR=1) (Messwerte(1,j), j=1,4)
        n_MW = MAX0(NINT(Messwerte(1,1)),NINT(Messwerte(1,3)))
        do i=1, n_MW
          read(7,*,ERR=1) (Messwerte(i+1,j), j=1,4)
        end do

        Status = 0
    1   close(7)
      end if

      End

